snippet alpine-to-alpine:
  prefix: "dockerfile-alpine-to-alpine"
  name: "alpine-to-alpine"
  description: "best practice: change the base image"
  scope: "dockerfile"
  body: |
    FROM alpine:3.17.2 AS final

snippet copy-public-directory:
  prefix: "docker-copy-public-directory"
  name: "copy-public-directory"
  description: "copy public directory after `USER appuser`"
  scope: "dockerfile"
  body: |
    WORKDIR /app
    # copy and give the rights to the user
    COPY --chown=appuser public ./public 
    COPY --from=build /bin/server .

snippet entrypoint:
  prefix: "docker-entrypoint"
  name: "entrypoint"
  description: "entrypoint script"
  scope: "dockerfile"
  body: |
    #ENTRYPOINT [ "/bin/server" ]
    ENTRYPOINT [ "./server" ]

snippet environment-compose:
  prefix: "compose-env"
  name: "environment"
  description: "add environment to service"
  scope: "yaml"
  body: |
    environment:
      - MESSAGE=🎉 Hello from 🐳 Compose 👋
      - REDIS_URL=redis-server:6379

snippet redis-compose:
  prefix: "compose-redis-service"
  name: "redis-service"
  description: "add redis-service"
  scope: "yaml"
  body: |
    redis-server:
      image: redis:7.2.4
      environment: 
        - REDIS_ARGS=--save 30 1
      volumes:
        - redis-data:/data
      ports:
        - 6379:6379

    bulk-loading:
      image: redis:7.2.4
      entrypoint: ["/load-data/bulk_loading.sh"]
      volumes:
        - ./load-data:/load-data
      depends_on:
        redis-server:
          condition: service_started

    volumes:
      redis-data:

snippet watch-compose:
  prefix: "compose-watch"
  name: "watch"
  description: "add watch section to the main service"
  scope: "yaml"
  body: |
    develop:
      watch:
        - action: sync
          path: ./public
          target: /app/public
        - action: rebuild
          path: ./Dockerfile
        - action: rebuild
          path: ./main.go

snippet new-stage:
  prefix: "docker-new-stage"
  name: "new stage"
  description: "new stage"
  scope: "dockerfile"
  body: |
    FROM scratch AS final
    WORKDIR /app
    COPY --from=certificates /etc/ssl/certs/ca-certificates.crt /etc/ssl/certs/
    COPY --from=build /bin/server .
    COPY public ./public 
